#creates a boxplot with the settings given in the config file
#parameter: config-file
if(TRUE){
ARGS<-commandArgs(TRUE)
if(length(ARGS)==0)
{
	stop("No parameter given.\n\nUsage: Rscript boxplot.R boxplot.config\n\n")
}
configPath<-ARGS[1]
}
source("utils.R")
config<-getConfig(configPath)
config<-checkIfParamsExist(config,paramNames=c("data"))
data<-read.table(config["data"])

defaults<-c("x label"="",
			"y label"="data",
			"log y"=FALSE,
			"title"="",
			"box names"=NA)
config<-checkIfParamsExist(config,paramNames=c("x label", "y label", "format", "out path", "title", "log y", "box names"), defaults=defaults, numericParams=NULL, logicalParams=c("log y"))

logged<-""
if(as.logical(config["log y"]))
{
	logged<-paste(logged,"y",sep="")
}


startDevice(config["format"],config["out path"])
boxplot(data, log=logged, xlab=config["x label"], ylab="y label",names=strsplit(config["box names"],split="\t")[[1]])
axesCoord<-getAxesCoordinates();
cat(axesCoord$my.x,"\n")
cat(axesCoord$my.y,"\n")
cat(axesCoord$dev.x,"\n")
cat(axesCoord$dev.y,"\n")
dev.off()
