#creates a histogram with the settings given in the config file
#parameter: config-file
if(TRUE){
ARGS<-commandArgs(TRUE)
if(length(ARGS)==0)
{
	stop("No parameter given.\n\nUsage: Rscript histogram.R histogram.config\n\n")
}
configPath<-ARGS[1]
}
source("utils.R")
config<-getConfig(configPath)
config<-checkIfParamsExist(config,paramNames=c("data"))
data<-read.table(config["data"])

defaults<-c("x start" = min(data[,1]),
			"x end" = max(data[,1]),
			"x label"="",
			"y label"="Frequency",
			"cumulative"=FALSE,
			"breaks"="sturges",
			"title"="")
config<-checkIfParamsExist(config,paramNames=c("x start","x end","x label","y label","format","out path","title","breaks","cumulative"),defaults=defaults,numericParams=c("x start","x end","breaks"),logicalParams=c("cumulative"))

cumHist<-function(data, xstart, xend, ...)
{
	t<-table(data[data>=xstart & data<=xend])
	cumData<-NULL
	for(i in 1:length(t))
	{
		cumData<-c(cumData,sum(t[1:i]))
	}
	plot(as.numeric(names(t)),cumData,ylim=c(0,max(cumData)), type='l', ...)
}

lineHist<-function(x,breaks = "Sturges", freq = NULL, include.lowest = TRUE, right = TRUE, density = NULL, angle = 45, border = NULL, main = paste("Histogram of", xname), xlab = xname, labels = FALSE, nclass = NULL, warn.unused = TRUE, add=F, withPoints=T, ...){
    h<-hist(x,breaks=breaks,freq=freq, include.lowest=include.lowest, right=right, density=density, angle=angle, col=col, border=border, warn.unused=warn.unused,  labels=labels, plot=F)
    if(!add){
        plot(h$mids,h$counts,ylab="frequency",type='l',xlab=xlab, ...)
    }
    else{
        lines(h$mids,h$counts,ylab="frequency",...)
    }
    if(withPoints){
        points(h$mids,h$counts,ylab="frequency",...)
    }
}


breaks<-config["breaks"]
cat(breaks,"\n")
if(!is.na(as.numeric(config["breaks"])))
{
	breaks<-as.numeric(config["breaks"])
}
startDevice(config["format"],config["out path"])
if(!as.logical(config["cumulative"]))
{
	hist(data[,1], breaks=breaks, xlab=config["x label"], ylab=config["y label"], xlim=as.numeric(c(config["x start"],config["x end"])), main=config["title"])
} else
{
	cumHist(data[,1], as.numeric(config["x start"]), as.numeric(config["x end"]), ylab=config["y label"], xlab=config["x label"], main=config["title"])
}
axesCoord<-getAxesCoordinates();
cat("coord my.x :",axesCoord$my.x,"\n")
cat("coord my.y :",axesCoord$my.y,"\n")
cat("coord dev.x :",axesCoord$dev.x,"\n")
cat("coord dev.y. :",axesCoord$dev.y,"\n")
dev.off()

