#creates a scatter plot with the settings given in the config file
#parameter: config-file
if(TRUE){
ARGS<-commandArgs(TRUE)
if(length(ARGS)==0)
{
	stop("No parameter given.\n\nUsage: Rscript scatter.R scatter.config\n\n")
}
configPath<-ARGS[1]
}
source("utils.R")
config<-getConfig(configPath)
config<-checkIfParamsExist(config,paramNames=c("data"))
data<-read.table(config["data"], stringsAsFactors=F)

defaults<-c("x start" = min(data[,1]),
			"x end" = max(data[,1]), 
			"y start"=min(data[,2]), 
			"y end"=max(data[,2]), 
			"x label"="",
			"y label"="",
			"x log"=FALSE,
			"y log"=FALSE,
			"point style"=1,
			"point scale"=1,
			"title"="",
			"hexbin"=FALSE)
config<-checkIfParamsExist(config,paramNames=c("x start","x end","y start","y end","x label","y label","x log","y log","point style","point scale","format","out path","title","hexbin"),defaults=defaults,numericParams=c("x start","x end","y start","y end","point style","point scale"),logicalParams=c("x log","y log","hexbin"))

logged<-""
if(as.logical(config["x log"]))
{
	logged<-paste(logged,"x",sep="")
}
if(as.logical(config["y log"]))
{
	logged<-paste(logged,"y",sep="")
}


startDevice(config["format"],config["out path"])
if(as.logical(config["hexbin"]){
	library(hexbin)
	indX<-which(data[,1]>=as.numeric(config["x start"]) & data[,1]<=as.numeric(config["x end"]))
	indY<-which(data[,2]>=as.numeric(config["y start"]) & data[,2]<=as.numeric(config["y end"]))
	plot(hexbin(data[indX,1],data[indY,2]),main=config["title"],xlab=config["x label"], ylab=config["y label"])
}
else{
	plot(data[,1],data[,2],xlim=as.numeric(c(config["x start"],config["x end"])),ylim=as.numeric(c(config["y start"],config["y end"])),xlab=config["x label"],ylab=config["y label"],log=logged, pch=as.numeric(config["point style"]),cex=as.numeric(config["point scale"]),main=config["title"])
}

axesCoord<-getAxesCoordinates();
cat("coord my.x :",axesCoord$my.x,"\n")
cat("coord my.y :",axesCoord$my.y,"\n")
cat("coord dev.x :",axesCoord$dev.x,"\n")
cat("coord dev.y :",axesCoord$dev.y,"\n")
dev.off()

